###############################################################################
# YaBB.pl                                                                     #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.2                                        #
# Released:       December 2001; Updated March 12, 2003                       #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################

$subsplver = "1 Gold - SP 1.3";

sub NewSearch {
	my( @categories, %cat, $curcat, %catname, %cataccess, %catboards, $openmemgr, @membergroups, $tmpa, %openmemgr, $curboard, @threads, @boardinfo, $counter );
	@categories = ();
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);

	# Load Censor List
	&LoadCensorList;

	$yytitle = $txt{'183'};
	
	$searchpageurl = $curposlinks ? qq~<a href="$scripturl?action=searchnew" class="nav">$txt{'182'}</a>~ : $txt{'182'};
	$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!-- Begin
function changeBox(cbox) {
box = eval(cbox);
box.checked = !box.checked;
}
//  End -->
</script>
<script language="JavaScript">
<!--
function checkAll() {
  for (var i = 0; i < document.searchform.elements.length; i++) {
  	if(document.searchform.elements[i].name != "method") {
    		document.searchform.elements[i].checked = true;
    	}
  }
}
function uncheckAll() {
  for (var i = 0; i < document.searchform.elements.length; i++) {
  	if(document.searchform.elements[i].name != "method") {
    		document.searchform.elements[i].checked = false;
    	}
  }
}
//-->
</script>
<table width="98%" align="center" border="0" cellpadding="3" cellspacing="0">
  <tr>
    <td><font size=2 class="nav"><img src="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;<b><a href="$scripturl" class="nav">$mbname</a></b><br><img src="$imagesdir/tline.gif" BORDER=0><img src="$imagesdir/open.gif" border=0>&nbsp;&nbsp;<b>$searchpageurl</b></font></td>
  </tr>
</table>

<table border=0 width="98%" cellspacing=1 cellpadding=4 bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}"><font size=2 class="text1" color="$color{'titletext'}">$txt{'582'} $txt{'302'}</font></td>
  </tr><tr>
    <td bgcolor="$color{'windowbg'}">
    <form action="$scripturl?action=searchnewresults" method="post" name="searchform">

~;
    # We can only do this search for valid users
    if ($username ne 'Guest') {
        $yymain .=qq~ <font size=\"2\"><INPUT NAME=\"method\" TYPE=radio VALUE=\"byacct\" CHECKED> $searchnew{'01'}<BR>
		<p><INPUT NAME=\"method\" TYPE=radio VALUE=\"bytime\" > $searchnew{'02'}</font> ~;
    } else {
	$yymain .=qq~ <font size=\"2\"><INPUT NAME=\"method\" TYPE=radio VALUE=\"bytime\" CHECKED > $searchnew{'02'}</font> ~;
    }
$yymain .= qq~
        <table border="0" cellpadding="2" cellspacing="0">
          <tr>
            <td>&nbsp;</td>
            <td><font size="2">
            $txt{'575'}:</td><td><font size="2">
            <input type=text name="minagehours" value=0 size=3 maxlength=5> $txt{'578'} +
            <input type=text name="minagedays" value=0 size=5 maxlength=5> $txt{'579'}.
            </font></td>
          </tr><tr>
            <td>&nbsp;</td>
            <td><font size="2">
            $txt{'576'}:</td><td><font size="2">
            <input type=text name="maxagehours" value=0 size=3 maxlength=5> $txt{'578'} +
            <input type=text name="maxagedays" value=1 size=5 maxlength=5> $txt{'579'}.</font></td>
          </tr>
        </table>


    <hr size="1" width="100%" color="$color{'windowbg3'}" class="windowbg3">
    <B>$txt{'189'}:</B><br></font>
    <table width="80%" border="0" cellpadding="1" cellspacing="0">
        <tr>
~;
	$counter = 1;
	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$catname{$curcat} = <FILE>;
		chomp $catname{$curcat};
		$cataccess{$curcat} = <FILE>;
		chomp $cataccess{$curcat};
		@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		@membergroups = split( /,/, $cataccess{$curcat} );
		$openmemgr{$curcat} = 0;
		foreach $tmpa (@membergroups) { if($tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; last; } }
		if(!$cataccess{$curcat} || $settings[7] eq 'Administrator') { $openmemgr{$curcat} = 1; }
		unless($openmemgr{$curcat}) { next; }

		boardcheck: foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			my $access = &AccessCheck($curboard, '');
			if ($settings[7] ne "Administrator" && $access ne "granted" && $showprivboards{$curboard} ne "0") {next;}
			fopen(FILE, "$boardsdir/$curboard.dat");
			@boardinfo = <FILE>;
			fclose(FILE);
			chomp @boardinfo;
			@{$boardinfo{$curboard}} = @boardinfo;
			$cat{$curboard} = $curcat;
			$yymain .= qq~<td width="50%"><font size="2"><input type=checkbox name="brd$counter" value="$curboard" checked><span id="spanbrd$counter" style="cursor:hand;" onClick="changeBox('document.searchform.brd$counter')">$boardinfo[0]</span></font></td>~;
			unless( $counter % 2 ) { $yymain .= q~</tr><tr>~; }
			++$counter;
		}
	}

	$yymain .= qq~
      </tr>
    </table><BR>
    <INPUT TYPE="checkbox" ONCLICK="if (this.checked) checkAll(); else uncheckAll();" checked><font size="2"><i>$txt{'737'}</i></font>
    <BR><font size="2">

    <hr size="1" width="100%" color="$color{'windowbg3'}" class="windowbg3">
    <table border="0" cellpadding="2" cellspacing="0" align="center">
      <tr>
        <td valign="bottom"><font size="2">&nbsp;</td>
        <td valign="bottom"><font size="2">
        <input type=hidden name=action value=dosearch>
        <input type="submit" name="submit" value="$txt{'182'}"></font></td>
      </tr>
    </table>
    </form>
    </td>
  </tr>
</table>
~;
	&template;
	exit;
}


##################################################################################
sub NewSearchResults {

	### Get and Validate Form Values

	my $searchmethod = $FORM{'method'} || "bytime";
	my $minhours = $FORM{'minagehours'} || 0;
	my $mindays = $FORM{'minagedays'} || 0;
	my $maxhours = $FORM{'maxagehours'} || 0;
	my $maxdays = $FORM{'maxagedays'} || 0;
	if( $minhours =~ /\D/ ) { &fatal_error($txt{'337'}); }
	if( $mindays =~ /\D/ ) { &fatal_error($txt{'337'}); }
	if( $maxhours =~ /\D/ ) { &fatal_error($txt{'337'}); }
	if( $maxdays =~ /\D/ ) { &fatal_error($txt{'337'}); }

	my( $curboard, @threads, $curthread, $tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate, $ttime, @messages, $curpost, $mtime, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mns, $subfound, $msgfound, $numfound, %data, $i, $board, $curcat, @categories, %catname, %cataccess, %openmemgr, @membergroups, %cats, @boardinfo, %boardinfo, @boards, $counter, $msgnum, $dlp);
	my($tispoll);

	my($counta, $countb, $countc, $threaddate);
	$countc=0;

	my $curtime = time + (3600*$timeoffset);
	my $minage = $curtime - (($mindays*86400)+($minhours*3600) - 1);
	my $maxage = $curtime - (($maxdays*86400)+($maxhours*3600) + 1);
	my $oldestfound = stringtotime("01/10/37 $txt{'107'} 00:00:00");

	$yytitle = $txt{'166'};
	$yymain .=qq~ <table border=0 width=\"100%\" cellspacing=1 cellpadding=4 bgcolor=\"$color{'bordercolor'}\" class=\"bordercolor\" align=\"center\">
		<tr><td colspan=2 bgcolor=\"$color{'titlebg'}\"><font class=\"text1\" color=\"$color{'titletext'}\" size=2><b>$yytitle</b></font></td></tr>
		<tr><td colspan=2 bgcolor=\"$color{'windowbg'}\"> ~;
        ############################################################
	# Figure out which categories this user can/wants to access
        ############################################################
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);

	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$catname{$curcat} = <FILE>;
		chomp $catname{$curcat};
		$cataccess{$curcat} = <FILE>;
		chomp $cataccess{$curcat};
		@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		@membergroups = split( /,/, $cataccess{$curcat} );
		$openmemgr{$curcat} = 0;
		foreach $tmpa (@membergroups) { if($tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; last; } }
		if(!$cataccess{$curcat} || $settings[7] eq 'Administrator') { $openmemgr{$curcat} = 1; }
		unless($openmemgr{$curcat}) { next; }

		boardcheck: foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			my $access = &AccessCheck($curboard, '');
			if ($settings[7] ne "Administrator" && $access ne "granted" && $showprivboards{$curboard} ne "0") {next;}
			fopen(FILE, "$boardsdir/$curboard.dat");
			@boardinfo = <FILE>;
			fclose(FILE);
			chomp @boardinfo;
			@{$boardinfo{$curboard}} = @boardinfo;
			$cat{$curboard} = $curcat;
		}
	}

	# Which boards did user want to search?
	$counter = 1;
	while( $_ = each(%FORM) ) {
		unless( $_ =~ m~\Abrd(\d+)\Z~ ) { next; }
		$_ = $FORM{$_};
		if ($_ =~ m~/~){ &fatal_error($txt{'397'}); }
		if ($_ =~ m~\\~){ &fatal_error($txt{'397'}); }
		if( $cat{$_} ) { push( @boards, $_ ); }
		++$counter;
	}


        ######################################################################
	# Loop through boards, threads and posts looking for new messages
        ######################################################################

	boardcheck: foreach $curboard (@boards) {
		fopen(FILE, "$boardsdir/$curboard.txt") || next;
		@threads = <FILE>;
		fclose(FILE);
		#$yymain .= qq~<ol>Beginning search in board $curboard<ol>~;

		$counta=0;
		threadcheck: foreach $curthread (@threads) {
			$countb=0;
			chomp $curthread;
  			#$yymain .= qq~</ol>Beginning search in thread $curthread.<ol>~;
			($tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate, $tispoll) = split( /\|/, $curthread );

			$threaddate = stringtotime($tdate);

			###################################################################
			# Check Date/Time at thread level (avoids unnecessary searching).
			###################################################################

			if ($searchmethod eq 'byacct') {
				# Figure out if the user read this thread.
				$dlp = &getlog($tnum);
				if( $dlp == $threaddate || &getlog("$curboard--mark") > $threaddate ) {next threadcheck; }
			} 
 			else { 
				if( $threaddate > $minage ) { next threadcheck; }
                                if( $threaddate < $maxage ) { next boardcheck; }
			}
			
			# At this point, we know this thread has a new message

			fopen(FILE, "$datadir/$tnum.txt") || next;
			@messages = <FILE>;
			fclose(FILE);
		
			#############################################
			# Check all posts in thread for new messages.	
			#############################################

			$countb=0;

			postcheck: for( $msgnum = 0; $msgnum < @messages; $msgnum++ ) {
				#$yymain .= qq~Beginning search in post $curpost.<br>~;
				$curpost = $messages[$msgnum];
				chomp $curpost;
				($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = split(/\|/,$curpost);
				
				$threaddate = stringtotime($mdate);

				if ($searchmethod eq 'byacct') {
					# Figure out if the user read this post.
					if( $dlp >= $threaddate || &getlog("$curboard--mark") > $threaddate ) { next postcheck; }
				} 
	 			else { 

					if( $threaddate > $minage ) { next postcheck; }
        	                        if( $threaddate < $maxage ) { next postcheck; }
				}
				# Remove line breaks and crop to first 60 characters.		
				$message =~ s/<br>//gi;
				$message = substr($message, 0, 60);				

#cat van
			if($counta == 0){
				$yymain .=qq~ <font color=\"$color{'titletext'}\" size=2>
					<img align=\"top\" src=\"$imagesdir/open.gif\" border=\"0\">&nbsp;
					<a href=\"$scripturl?board=$curboard\"><b>$boardinfo{$curboard}->[0]</b></a></font><br>
			            ~;
			}
			++$counta;

#cat van vge
#board van
			if($countb == 0){
				$yymain .=qq~ <font color=\"$color{'titletext'}\" size=2><img align=\"top\" src=\"$imagesdir/search_t.gif\" border=\"0\"><img align=\"top\" src=\"$imagesdir/open.gif\" border=\"0\">
				<a href=\"$scripturl?board=$curboard;action=display;num=$tnum\"><b>$tsub</b></a></font><br>
				~;
			}
			++$countb;

#board van

				
				$yymain .= qq~ <font size=1><img align=\"top\" src=\"$imagesdir/search_i.gif\" border=\"0\"><img align=\"top\" src=\"$imagesdir/search_t.gif\" border=\"0\"><img align=\"top\" src=\"$imagesdir/search_line.gif\" border=\"0\">
				$mdate - $mname : <a href=\"$scripturl?board=$curboard;action=display;num=$tnum;start=$msgnum#$msgnum\"> 
				" $message ..."</font> </a> <br>
				~;
				++$countc

			}
		}
	}
          
$yymain .= qq~
<br></td></tr>
<tr bgcolor="$color{'windowbg2'}">
   <td valign=top><font size=1>$txt{'167'}: &nbsp;$countc $txt{'174'}<br><br><a href="$cgi">$txt{'236'}</a> $txt{'237'}</font></td>
   <td align=right valign=top><font size=1><a href="$scripturl?action=markallasread">$img{'markallread'}</a></font></td>
</tr>
</table>


~;
	&template; 
	exit;
}
